Imports RootPro.RootProCAD
Imports RootPro.RootProCAD.Command
Imports RootPro.RootProCAD.Geometry

'-----------------------------------------------------------------------------------------------
' }`̃o[oh`悷AhCTv
' R}hsɐ}`̃o[oh`悵܂
' Copyright @ 2017 RootPro Co.,Ltd. 
'-----------------------------------------------------------------------------------------------
<System.AddIn.AddIn("AppAddIn", Version:="1.0", Publisher:="", Description:="")>
Partial Class AppAddIn

    Private CircleRubberBandCommandName As String = "CircleRubberBandVB"

    Private Sub AppAddIn_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        Dim parentMenus() As String = {"o[oh`"}

        'R}h̒ǉ
        CommandManager.AddMacroCommand("RCAddInShapeRubberBandVB", parentMenus, "~", AddressOf Me.MacroCommand)

        'R}hǉ
        Dim command As Command = CommandManager.AddCommand(CircleRubberBandCommandName)
        command.Name = "~"
        'p[^̒ǉ
        AddParameters(command)

        'JnCxgƏICxg̒ǉ
        AddHandler command.Begin, AddressOf command_Begin
        AddHandler command.End, AddressOf command_End

    End Sub

    Private Sub AppAddIn_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        CommandManager.RemoveMacroCommand(AddressOf MacroCommand)
    End Sub


    ''' <summary>
    ''' p[^ǉ
    ''' </summary>
    ''' <param name="command">R}h</param>
    Private Sub AddParameters(ByVal command As Command)

        command.ParameterGroups.Add(ParameterItemType.Point, 0, "S_")
        Dim pointParameterItem As PointParameterItem = DirectCast(command.GetParameterItemByID(0), PointParameterItem)
        pointParameterItem.Description = "~̒SW͂܂B"

        command.ParameterGroups.Add(ParameterItemType.Multiple, 1, "a")
        Dim multipleParameterItem As MultipleParameterItem = DirectCast(command.GetParameterItemByID(1), MultipleParameterItem)
        multipleParameterItem.Description = "~̔a܂͒ʉߓ_͂܂B"

        multipleParameterItem.ParameterTypeFlags = ParameterItemTypeFlags.Point Or ParameterItemTypeFlags.Length
    End Sub



    ''' <summary>
    ''' R}h̊JnɌĂ΂
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub command_Begin(ByVal sender As Object, ByVal e As CommandBeginEventArgs)
        Dim command As Command = DirectCast(sender, Command)

        'p[^ύXCxg̒ǉ
        AddHandler command.ParameterChanged, AddressOf command_ParameterChanged
        '}EXړCxg̒ǉ
        AddHandler command.MouseMove, AddressOf command_MouseMove
    End Sub

    ''' <summary>
    ''' R}h̏IɌĂ΂
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub command_End(ByVal sender As Object, ByVal e As EventArgs)
        Dim command As Command = DirectCast(sender, Command)

        'p[^ύXCxg̍폜
        RemoveHandler command.ParameterChanged, AddressOf command_ParameterChanged
        '}EXړCxg̍폜
        RemoveHandler command.MouseMove, AddressOf command_MouseMove
    End Sub

    ''' <summary>
    ''' p[^ωƂɌĂ΂
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub command_ParameterChanged(ByVal sender As Object, ByVal e As CommandParameterChangedEventArgs)
        Dim doc As Document = ActiveDocument
        Dim command As Command = DirectCast(sender, Command)

        Dim id As Integer = e.ParameterID

        ' R}hp[^̃`FbN
        Dim pointParameterItem As PointParameterItem = DirectCast(command.GetParameterItemByID(0), PointParameterItem)

        If pointParameterItem.IsEmpty Then
            Return
        End If

        Dim multipleParameterItem As MultipleParameterItem = DirectCast(command.GetParameterItemByID(1), MultipleParameterItem)
        If multipleParameterItem.IsEmpty Then
            Return
        End If

        ' UNDO \ȑJn
        doc.UndoManager.BeginUndoUnit()

        Dim drawing As Drawing = doc.CurrentDrawing

        ' R}hp[^璆S_Aa擾
        Dim radiusPointItem As PointParameterItem = multipleParameterItem.GetParameterItem(ParameterItemType.Point)
        Dim lengthParameterItem As LengthParameterItem = multipleParameterItem.GetParameterItem(ParameterItemType.Length)

        Dim radius As Double
        If Not lengthParameterItem.IsEmpty Then
            radius = lengthParameterItem.Length
        ElseIf Not radiusPointItem.IsEmpty Then
            radius = Geometry.GetDistance(pointParameterItem.Point, radiusPointItem.Point)
        End If

        ' ~}`ǉ
        drawing.Shapes.AddCircle(pointParameterItem.Point, radius)

        ' UNDO \ȑI
        doc.UndoManager.EndUndoUnit()

        e.CommandState = CommandState.Execute
    End Sub

    Private Sub MacroCommand()
        'R}h̎s
        CommandManager.ExecuteCommand(CircleRubberBandCommandName)
    End Sub

    ''' <summary>
    ''' }EXړƂɌĂ΂
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub command_MouseMove(ByVal sender As Object, ByVal e As CommandMouseMoveEventArgs)
        Dim command As Command = DirectCast(sender, Command)

        ' Command.GetTemporaryParameterItemByID gpăR}ḧꎞIȃp[^ACe擾܂B
        ' ꎞIȃp[^ACéAłɃp[^̓͂m肵Ăꍇ͊m肵Ă͒lA
        ' ͂m肵ĂȂꍇ̓}EX݈̌ʒuȂǂ̈ꎞIȒl擾ł܂B

        ' S_̈ꎞp[^擾
        Dim pointParameterItem As PointParameterItem = DirectCast(command.GetTemporaryParameterItemByID(0), PointParameterItem)
        If pointParameterItem.IsEmpty Then
            Return
        End If

        ' a/ʉߓ_̈ꎞp[^擾
        Dim multipleParameterItem As MultipleParameterItem = DirectCast(command.GetTemporaryParameterItemByID(1), MultipleParameterItem)
        If multipleParameterItem.IsEmpty Then
            Return
        End If

        ' p[^甼a擾
        Dim radius As Double
        Dim radiusPointItem As PointParameterItem = multipleParameterItem.GetParameterItem(ParameterItemType.Point)
        Dim lengthParameterItem As LengthParameterItem = multipleParameterItem.GetParameterItem(ParameterItemType.Length)

        If Not lengthParameterItem.IsEmpty Then
            radius = lengthParameterItem.Length
        ElseIf Not radiusPointItem.IsEmpty Then
            radius = Geometry.GetDistance(pointParameterItem.Point, radiusPointItem.Point)
        End If

        If radius = 0 Then
            Return
        End If

        ' o[oh`悷~쐬
        Dim circle As CircleShape = ShapeFactory.CreateCircle(pointParameterItem.Point, radius)
        ' o[oh̐Fݒ
        circle.ColorNumber = 3

        Try
            ' }`̃o[oh`悷
            command.DrawShapeRubberBand(circle)
        Catch
            Throw
        End Try
    End Sub
End Class
